| coderet

## Function

Extract CDS, mRNA and translations from feature tables

## Description

The feature table of sequence database entries often have sections like this:

This specifies that the coding sequence for the gene is constructed by joining several sections of code, many of which are in other entries in this database.

    FT   CDS             join(U21925.1:818..987,U21926.1:258..420,
    FT                   U21927.1:428..520,U21928.1:196..336,U21929.1:279..415,
    FT                   U21930.1:895..1014,516..708)

or:

This specifies that the messenger RNA sequence for the gene is constructed by joining several sections of code, many of which are in other entries in this database.

    FT   mRNA            join(M88628.1:1006..1318,M88629.1:221..342,
    FT                   M88630.1:101..223,M88631.1:46..258,M88632.1:104..172,
    FT                   M88633.1:387..503,M88634.1:51..272,M88635.1:303..564,
    FT                   M88635.1:849..1020,M88636.1:282..375,M88637.1:39..253,
    FT                   M88638.1:91..241,M88639.1:168..377,M88640.1:627..3732,
    FT                   M88641.1:158..311,M88642.1:1051..1263,M88642.1:1550..1778,
    FT                   M88642.1:1986..2168,M88642.1:3904..4020,
    FT                   M88642.1:4627..4698,M88643.1:39..124,M88644.1:42..197,
    FT                   M88645.1:542..686,M88646.1:75..223,M88647.1:109..285,
    FT                   253..2211)

or:

This specifies that the translation of the coding region is as follows.

    FT                   /translation="MAQDSVDLSCDYQFWMQKLSVWDQASTLETQQDTCLHVAQFQEFL
    FT                   RKMYEALKEMDSNTVIERFPTIGQLLAKACWNPFILAYDESQKILIWCLCCLINKEPQN
    FT                   SGQSKLNSWIQGVLSHILSALRFDKEVALFTQGLGYAPIDYYPGLLKNMVLSLASELRE
    FT                   NHLNGFNTQRRMAPERVASLSRVCVPLITLTDVDPLVEALLICHGREPQEILQPEFFEA
    FT                   VNEAILLKKISLPMSAVVCLWLRHLPSLEKAMLHLFEKLISSERNCLRRIECFIKDSSL
    FT                   PQAACHPAIFRVDEMFRCALLETDGALEIIATIQVFTQCFVEALEKASKQLRFALKTYF
    FT                   PYTSPSLAMVLLQDPQDIPRGHWLQTLKHISELLREAVEDQTHGSCGGPFESWFLFIHF
    FT                   GGWAEMVAEQLLMSAAEPPTALLWLLAFYYGPRDGRQQRAQTMVQVKAVLGHLLAMSRS
    FT                   SSLSAQDLQTVAGQGTDTDLRAPAQQLIRHLLLNFLLWAPGGHTIAWDVITLMAHTAEI
    FT                   THEIIGFLDQTLYRWNRLGIESPRSEKLARELLKELRTQV"

It is often a tedious and error-prone job to extract the several sections of these sequences from the database entries and to join them together to construct the indicated finished sequence.

coderet does this job for you.

You specify the sequence containing the feature table and it extracts the required CDS, mRNA and/or protein sequences specified by this feature table. If any sequences are in other entries of that database, they are automatically fetched and incorporated correctly into the final sequence.

The translations are not made from the coding sequence, they are extracted directly from the translation sequence held in the feature table.

## Usage

Here is a sample session with coderet

To extract all of the CDS, mRNA and the protein translations:

    % coderet
    Extract CDS, mRNA and translations from feature tables
    Input sequence(s): tembl:X03487
    Output sequence [hsferg1.fasta]:

Go to the input files for this example
Go to the output files for this example

Example 2

To only extract the mRNA sequence:

    % coderet -nocds -notranslation
    Extract CDS, mRNA and translations from feature tables
    Input sequence(s): tembl:X03487
    Output sequence [hsferg1.fasta]:

Go to the output files for this example

## Command line arguments

       Standard (Mandatory) qualifiers:
      [-seqall]            seqall     Sequence database USA
      [-outseq]            seqout     Output sequence USA

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -[no]cds            boolean    Extract CDS sequences
       -[no]mrna           boolean    Extract mrna sequences
       -[no]translation    boolean    Extract translated sequences

       Associated qualifiers:

       "-seqall" associated qualifiers
       -sbegin1             integer    Start of each sequence to be used
       -send1               integer    End of each sequence to be used
       -sreverse1           boolean    Reverse (if DNA)
       -sask1               boolean    Ask for begin/end/reverse
       -snucleotide1        boolean    Sequence is nucleotide
       -sprotein1           boolean    Sequence is protein
       -slower1             boolean    Make lower case
       -supper1             boolean    Make upper case
       -sformat1            string     Input sequence format
       -sdbname1            string     Database name
       -sid1                string     Entryname
       -ufo1                string     UFO features
       -fformat1            string     Features format
       -fopenfile1          string     Features file name

       "-outseq" associated qualifiers
       -osformat2           string     Output seq format
       -osextension2        string     File name extension
       -osname2             string     Base file name
       -osdirectory2        string     Output directory
       -osdbname2           string     Database name to add
       -ossingle2           boolean    Separate file for each entry
       -oufo2               string     UFO features
       -offormat2           string     Features format
       -ofname2             string     Features file name
       -ofdirectory2        string     Output directory

       General qualifiers:
       -auto                boolean    Turn off prompts
       -stdout              boolean    Write standard output
       -filter              boolean    Read standard input, write standard output
       -options             boolean    Prompt for standard and additional values
       -debug               boolean    Write debug output to program.dbg
       -verbose             boolean    Report some/full command line options
       -help                boolean    Report command line options. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning             boolean    Report warnings
       -error               boolean    Report errors
       -fatal               boolean    Report fatal errors
       -die                 boolean    Report deaths

Standard (Mandatory) qualifiers | Allowed values | Default
--- | --- | ---
[-seqall] (Parameter 1) | Sequence database USA | Readable sequence(s) | Required
[-outseq] (Parameter 2) | Output sequence USA | Writeable sequence | <sequence>.format
Additional (Optional) qualifiers | Allowed values | Default
(none)
Advanced (Unprompted) qualifiers | Allowed values | Default
-[no]cds | Extract CDS sequences | Boolean value Yes/No | Yes
-[no]mrna | Extract mrna sequences | Boolean value Yes/No | Yes
-[no]translation | Extract translated sequences | Boolean value Yes/No | Yes

## Input file format

coderet reads one or more nucleic sequence USAs having CDS, mRNA or translation headings in their feature tables.

### Input files for usage example

'tembl:X03487' is a sequence entry in the example nucleic acid database 'tembl'

### Database entry: tembl:X03487

    ID   HSFERG1    standard; DNA; HUM; 512 BP.
    XX
    AC   X03487;
    XX
    SV   X03487.1
    XX
    DT   02-JUL-1986 (Rel. 09, Created)
    DT   04-APR-1995 (Rel. 43, Last updated, Version 2)
    XX
    DE   Human apoferritin H gene exon 1
    XX
    KW   ferritin.
    XX
    OS   Homo sapiens (human)
    OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
    OC   Eutheria; Primates; Catarrhini; Hominidae; Homo.
    XX
    RN   [1]
    RP   1-512
    RX   MEDLINE; 86120367.
    RA   Costanzo F., Colombo M., Staempfli S., Santoro C., Marone M., Frank R.,
    RA   Delius H., Cortese R.;
    RT   "Structure of gene and pseudogenes of human apoferritin H";
    RL   Nucleic Acids Res. 14:721-736(1986).
    XX
    DR   EPD; EP11112; HS_FRIH.
    DR   SWISS-PROT; P02794; FRIH_HUMAN.
    XX
    FH   Key             Location/Qualifiers
    FH
    FT   source          1..512
    FT                   /db_xref="taxon:9606"
    FT                   /organism="Homo sapiens"
    FT   misc_feature    65..70
    FT                   /note="GGGCGG box"
    FT   misc_feature    103..108
    FT                   /note="GGGCGG box"
    FT   misc_feature    126..131
    FT                   /note="GGGCGG box"
    FT   promoter        150..154
    FT                   /note="put. TATA box"
    FT   mRNA            179..500
    FT                   /note="exon 1"
    FT   CDS             join(387..500,X03488.1:50..196,X03488.1:453..578,
    FT                   X03488.1:674..838)
    FT                   /db_xref="SWISS-PROT:P02794"
    FT                   /label=apoh_cds
    FT                   /product="apoferritin H subunit"
    FT                   /protein_id="CAA27205.1"
    FT                   /translation="MTTASTSQVRQNYHQDSEAAINRQINLELYASYVYLSMSYYFDRD
    FT                   DVALKNFAKYFLHQSHEEREHAEKLMKLQNQRGGRIFLQDIKKPDCDDWESGLNAMECA
    FT                   LHLEKNVNQSLLELHKLATDKNDPHLCDFIETHYLNEQVKAIKELGDHVTNLRKMGAPE
    FT                   SGLAEYLFDKHTLGDSDNES"
    FT   intron          501..>512
    FT                   /note="intron I"
    XX
    SQ   Sequence 512 BP; 80 A; 212 C; 152 G; 64 T; 4 other;
         agnncaaacc tnagctccgc cagagcgcgc gaggcctcca gcggccgccc ctcccccaca        60
         gcaggggcgg ggntcccgcg cccaccggaa ggagcgggct cggggcgggc ggcgctgatt       120
         ggccggggcg ggcctgacgc cgacgcggct ataagagacc acaagcgacc cgcagggcca       180
         gacgttcttc gccgagagtc gtcggggttt cctgcttcaa cagtgcttgg acggaacccg       240
         gcgctcgttc cccaccccgg ccggccgccc atagccagcc ctccgtcgac ctcttcaccg       300
         caccctcgga ctgccccaag gcccccgccg ccgctccagc gccgcgcagc caccgccgcc       360
         gccgccgcct ctccttagtc gccgccatga cgaccgcgtc cacctcgcag gtgcgccaga       420
         actaccacca ggactcagag gccgccatca accgccagat caacctggag ctctacgcct       480
         cctacgttta cctgtccatg gtgagcgcgg gc                                     512
    //

## Output file format

The output is a sequence file containing any CDS, mRNA and protein translation sequences as specified by the feature table of the sequence(s).

One or more of CDS, mRNA, translation can be excluded from the output by using the appropriate qualifiers to the program (i.e. -nocds, etc.)

The ID names of the output sequences are constructed from the name of the input sequence, the type of feature being output (i.e. cds, mrna, pro) and a unique ordinal number for this type to distinguish it from others in this sequence. The name, type and number of separated by underscore characters. Thus the second CDS feature in the sequence 'HSXYZ' would be named 'HSXYZ_cds_2'.

The translations are not made from the coding sequence, they are extracted directly from the translation sequence held in the feature table.

### Output files for usage example

### File: hsferg1.fasta

    >x03487_cds_1
    atgacgaccgcgtccacctcgcaggtgcgccagaactaccaccaggactcagaggccgcc
    atcaaccgccagatcaacctggagctctacgcctcctacgtttacctgtccatgtcttac
    tactttgaccgcgatgatgtggctttgaagaactttgccaaatactttcttcaccaatct
    catgaggagagggaacatgctgagaaactgatgaagctgcagaaccaacgaggtggccga
    atcttccttcaggatatcaagaaaccagactgtgatgactgggagagcgggctgaatgca
    atggagtgtgcattacatttggaaaaaaatgtgaatcagtcactactggaactgcacaaa
    ctggccactgacaaaaatgacccccatttgtgtgacttcattgagacacattacctgaat
    gagcaggtgaaagccatcaaagaattgggtgaccacgtgaccaacttgcgcaagatggga
    gcgcccgaatctggcttggcggaatatctctttgacaagcacaccctgggagacagtgat
    aatgaaagctaa
    >x03487_mrna_1
    cagacgttcttcgccgagagtcgtcggggtttcctgcttcaacagtgcttggacggaacc
    cggcgctcgttccccaccccggccggccgcccatagccagccctccgtcgacctcttcac
    cgcaccctcggactgccccaaggcccccgccgccgctccagcgccgcgcagccaccgccg
    ccgccgccgcctctccttagtcgccgccatgacgaccgcgtccacctcgcaggtgcgcca
    gaactaccaccaggactcagaggccgccatcaaccgccagatcaacctggagctctacgc
    ctcctacgtttacctgtccatg
    >x03487_pro_1
    MTTASTSQVRQNYHQDSEAAINRQINLELYASYVYLSMSYYFDRDDVALKNFAKYFLHQS
    HEEREHAEKLMKLQNQRGGRIFLQDIKKPDCDDWESGLNAMECALHLEKNVNQSLLELHK
    LATDKNDPHLCDFIETHYLNEQVKAIKELGDHVTNLRKMGAPESGLAEYLFDKHTLGDSD
    NES

### Output files for usage example 2

### File: hsferg1.fasta

    >x03487_mrna_1
    cagacgttcttcgccgagagtcgtcggggtttcctgcttcaacagtgcttggacggaacc
    cggcgctcgttccccaccccggccggccgcccatagccagccctccgtcgacctcttcac
    cgcaccctcggactgccccaaggcccccgccgccgctccagcgccgcgcagccaccgccg
    ccgccgccgcctctccttagtcgccgccatgacgaccgcgtccacctcgcaggtgcgcca
    gaactaccaccaggactcagaggccgccatcaaccgccagatcaacctggagctctacgc
    ctcctacgtttacctgtccatg

## Data files

None.

## Notes

The translations are not made from the coding sequence, they are extracted directly from the translation sequence held in the feature table.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
backtranseq | Back translate a protein sequence
extractfeat | Extract features from a sequence
maskfeat | Mask off features of a sequence
plotorf | Plot potential open reading frames
prettyseq | Output sequence with translated ranges
remap | Display a sequence with restriction cut sites, translation etc
showfeat | Show features of a sequence
showorf | Pretty output of DNA translations
showseq | Display a sequence with features, translation etc
sixpack | Display a DNA sequence with 6-frame translation and ORFs
transeq | Translate nucleic acid sequences
twofeat | Finds neighbouring pairs of features in sequences

## Author(s)

Alan Bleasby (ableasby © rfcgr.mrc.ac.uk)
MRC Rosalind Franklin Centre for Genomics Research Wellcome Trust Genome Campus, Hinxton, Cambridge, CB10 1SB, UK

## History

Written (Nov 2000) - Alan Bleasby.

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None